install.sh 7.3 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243
  1. #!/bin/sh
  2. # This script installs Ollama on Linux.
  3. # It detects the current operating system architecture and installs the appropriate version of Ollama.
  4. set -eu
  5. status() { echo ">>> $*" >&2; }
  6. error() { echo "ERROR $*"; exit 1; }
  7. warning() { echo "WARNING: $*"; }
  8. TEMP_DIR=$(mktemp -d)
  9. cleanup() { rm -rf $TEMP_DIR; }
  10. trap cleanup EXIT
  11. available() { command -v $1 >/dev/null; }
  12. require() {
  13. local MISSING=''
  14. for TOOL in $*; do
  15. if ! available $TOOL; then
  16. MISSING="$MISSING $TOOL"
  17. fi
  18. done
  19. echo $MISSING
  20. }
  21. [ "$(uname -s)" = "Linux" ] || error 'This script is intended to run on Linux only.'
  22. case "$(uname -m)" in
  23. x86_64) ARCH="amd64" ;;
  24. aarch64|arm64) ARCH="arm64" ;;
  25. *) error "Unsupported architecture: $ARCH" ;;
  26. esac
  27. SUDO=
  28. if [ "$(id -u)" -ne 0 ]; then
  29. # Running as root, no need for sudo
  30. if ! available sudo; then
  31. error "This script requires superuser permissions. Please re-run as root."
  32. fi
  33. SUDO="sudo"
  34. fi
  35. NEEDS=$(require curl awk grep sed tee xargs)
  36. if [ -n "$NEEDS" ]; then
  37. status "ERROR: The following tools are required but missing:"
  38. for NEED in $NEEDS; do
  39. echo " - $NEED"
  40. done
  41. exit 1
  42. fi
  43. status "Downloading ollama..."
  44. curl --fail --show-error --location --progress-bar -o $TEMP_DIR/ollama "https://ollama.ai/download/ollama-linux-$ARCH"
  45. for BINDIR in /usr/local/bin /usr/bin /bin; do
  46. echo $PATH | grep -q $BINDIR && break || continue
  47. done
  48. status "Installing ollama to $BINDIR..."
  49. $SUDO install -o0 -g0 -m755 -d $BINDIR
  50. $SUDO install -o0 -g0 -m755 $TEMP_DIR/ollama $BINDIR/ollama
  51. install_success() { status 'Install complete. Run "ollama" from the command line.'; }
  52. trap install_success EXIT
  53. # Everything from this point onwards is optional.
  54. configure_systemd() {
  55. if ! id ollama >/dev/null 2>&1; then
  56. status "Creating ollama user..."
  57. $SUDO useradd -r -s /bin/false -m -d /usr/share/ollama ollama
  58. fi
  59. status "Creating ollama systemd service..."
  60. cat <<EOF | $SUDO tee /etc/systemd/system/ollama.service >/dev/null
  61. [Unit]
  62. Description=Ollama Service
  63. After=network-online.target
  64. [Service]
  65. ExecStart=$BINDIR/ollama serve
  66. User=ollama
  67. Group=ollama
  68. Restart=always
  69. RestartSec=3
  70. Environment="HOME=/usr/share/ollama"
  71. Environment="PATH=$PATH"
  72. [Install]
  73. WantedBy=default.target
  74. EOF
  75. SYSTEMCTL_RUNNING="$(systemctl is-system-running || true)"
  76. case $SYSTEMCTL_RUNNING in
  77. running|degraded)
  78. status "Enabling and starting ollama service..."
  79. $SUDO systemctl daemon-reload
  80. $SUDO systemctl enable ollama
  81. start_service() { $SUDO systemctl restart ollama; }
  82. trap start_service EXIT
  83. ;;
  84. esac
  85. }
  86. if available systemctl; then
  87. configure_systemd
  88. fi
  89. if ! available lspci && ! available lshw; then
  90. warning "Unable to detect NVIDIA GPU. Install lspci or lshw to automatically detect and install NVIDIA CUDA drivers."
  91. exit 0
  92. fi
  93. check_gpu() {
  94. case $1 in
  95. lspci) available lspci && lspci -d '10de:' | grep -q 'NVIDIA' || return 1 ;;
  96. lshw) available lshw && $SUDO lshw -c display -numeric | grep -q 'vendor: .* \[10DE\]' || return 1 ;;
  97. nvidia-smi) available nvidia-smi || return 1 ;;
  98. esac
  99. }
  100. if check_gpu nvidia-smi; then
  101. status "NVIDIA GPU installed."
  102. exit 0
  103. fi
  104. if ! check_gpu lspci && ! check_gpu lshw; then
  105. warning "No NVIDIA GPU detected. Ollama will run in CPU-only mode."
  106. exit 0
  107. fi
  108. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-7-centos-7
  109. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-8-rocky-8
  110. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-9-rocky-9
  111. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#fedora
  112. install_cuda_driver_yum() {
  113. status 'Installing NVIDIA repository...'
  114. case $PACKAGE_MANAGER in
  115. yum)
  116. $SUDO $PACKAGE_MANAGER -y install yum-utils
  117. $SUDO $PACKAGE_MANAGER-config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-$1$2.repo
  118. ;;
  119. dnf)
  120. $SUDO $PACKAGE_MANAGER config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-$1$2.repo
  121. ;;
  122. esac
  123. case $1 in
  124. rhel)
  125. status 'Installing EPEL repository...'
  126. # EPEL is required for third-party dependencies such as dkms and libvdpau
  127. $SUDO $PACKAGE_MANAGER -y install https://dl.fedoraproject.org/pub/epel/epel-release-latest-$2.noarch.rpm || true
  128. ;;
  129. esac
  130. status 'Installing CUDA driver...'
  131. if [ "$1" = 'centos' ] || [ "$1$2" = 'rhel7' ]; then
  132. $SUDO $PACKAGE_MANAGER -y install nvidia-driver-latest-dkms
  133. fi
  134. $SUDO $PACKAGE_MANAGER -y install cuda-drivers
  135. }
  136. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#ubuntu
  137. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#debian
  138. install_cuda_driver_apt() {
  139. status 'Installing NVIDIA repository...'
  140. curl -fsSL -o $TEMP_DIR/cuda-keyring.deb https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-keyring_1.1-1_all.deb
  141. case $1 in
  142. debian)
  143. status 'Enabling contrib sources...'
  144. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list | sudo tee /etc/apt/sources.list.d/contrib.list > /dev/null
  145. ;;
  146. esac
  147. status 'Installing CUDA driver...'
  148. $SUDO dpkg -i $TEMP_DIR/cuda-keyring.deb
  149. $SUDO apt-get update
  150. [ -n "$SUDO" ] && SUDO_E="$SUDO -E" || SUDO_E=
  151. DEBIAN_FRONTEND=noninteractive $SUDO_E apt-get -y install cuda-drivers -q
  152. }
  153. if [ ! -f "/etc/os-release" ]; then
  154. error "Unknown distribution. Skipping CUDA installation."
  155. fi
  156. . /etc/os-release
  157. OS_NAME=$ID
  158. OS_VERSION=$VERSION_ID
  159. PACKAGE_MANAGER=
  160. for PACKAGE_MANAGER in dnf yum apt-get; do
  161. if available $PACKAGE_MANAGER; then
  162. break
  163. fi
  164. done
  165. if [ -z "$PACKAGE_MANAGER" ]; then
  166. error "Unknown package manager. Skipping CUDA installation."
  167. fi
  168. if ! check_gpu nvidia-smi || [ -z "$(nvidia-smi | grep -o "CUDA Version: [0-9]*\.[0-9]*")" ]; then
  169. case $OS_NAME in
  170. centos|rhel) install_cuda_driver_yum 'rhel' $OS_VERSION ;;
  171. rocky) install_cuda_driver_yum 'rhel' $(echo $OS_VERSION | cut -c1) ;;
  172. fedora) install_cuda_driver_yum $OS_NAME $OS_VERSION ;;
  173. amzn) install_cuda_driver_yum 'fedora' '35' ;;
  174. debian) install_cuda_driver_apt $OS_NAME $OS_VERSION ;;
  175. ubuntu) install_cuda_driver_apt $OS_NAME $(echo $OS_VERSION | sed 's/\.//') ;;
  176. *) exit ;;
  177. esac
  178. fi
  179. if ! lsmod | grep -q nvidia; then
  180. KERNEL_RELEASE="$(uname -r)"
  181. case $OS_NAME in
  182. centos|rhel|rocky|amzn) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE kernel-headers-$KERNEL_RELEASE ;;
  183. fedora) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE ;;
  184. debian|ubuntu) $SUDO apt-get -y install linux-headers-$KERNEL_RELEASE ;;
  185. *) exit ;;
  186. esac
  187. NVIDIA_CUDA_VERSION=$($SUDO dkms status | awk -F: '/added/ { print $1 }')
  188. if [ -n "$NVIDIA_CUDA_VERSION" ]; then
  189. $SUDO dkms install $NVIDIA_CUDA_VERSION
  190. fi
  191. if lsmod | grep -q nouveau; then
  192. status 'Reboot to complete NVIDIA CUDA driver install.'
  193. exit 0
  194. fi
  195. $SUDO modprobe nvidia
  196. fi
  197. status "NVIDIA CUDA drivers installed."